//	+-----------------------------------+
//	|		Calculator					|
//	|		by Zapk						|
//	|		Version:	2				|
//	|		RD:			July.6.2013		|
//	+-----------------------------------+

$ZapkCRPG_isKeybinds = true;
$remapDivision[$remapCount]	= "Calculator";
$remapName[$remapCount]			= "Open Calculator";
$remapCmd[$remapCount]			= "Calculator_Open";
$remapCount++;

function Calculator_Open() { canvas.pushDialog(Calculator); }

//	Load the GUI

exec("./Calculator.gui");

//	Parse Calculator Data

function Calculator_Parse(%string)
{
	%string = strReplace(%string, "(", "\(");
	%string = strReplace(%string, ")", "\)");
	%string = strReplace(%string, "x", "*");
	for(%i = 0; %i < getWordCount(%string); %i++)
	{
		if(getWord(%string, %i) $= "^" && %i != 0)
		{
			%f = getWord(%string, %i-1);
			%l = getWord(%string, %i+1);
			%string = setWord(%string, %i, mPow(%f, %l));
			%string = removeWord(removeWord(%string, %i+1), %i-1);
			%i = %i - 2;
		}
	}
	for(%i = 0; %i < strLen(%string); %i++)
	{
		if(strPos("0123456789. ()*/+-^", getSubStr(%string,%i,1)) == -1)
		{
			%fail = 1;
		}
	}
	if(!%fail)
	{
		%answer = eval("return " @ %string @ ";");
		%answer = strReplace(%answer, "1.#INF", "\c0Error");
		if(%answer $= "")
		{
			%answer = "\c0Error";
		}
		return %answer;
	}
	else
	{
		return "";
	}
}
function Calculator_ButtonPress(%button)
{
	if(%button $= "c")
	{
		$Calculator_String = "0";
		Calculator_Screen.setValue("\c7" @ $Calculator_String);
		return;
	}
	else if(%button $= "+" || %button $= "-" || %button $= "/" || %button $= "x" || %button $= "^")
	{
		if(lastWord($Calculator_String) $= "+" || lastWord($Calculator_String) $= "-" || lastWord($Calculator_String) $= "/" || lastWord($Calculator_String) $= "x" || lastWord($Calculator_String) $= "^")
		{
			$Calculator_String = $Calculator_String;
		}
		else
		{
			$Calculator_String = $Calculator_String SPC %button;
			Calculator_Screen.setValue("\c7" @ $Calculator_String);
		}
	}
	else if(%button $= "=")
	{
		$Calculator_String = Calculator_Parse($Calculator_String);
		Calculator_Screen.setValue("\c7" @ $Calculator_String);
	}
	else if(%button $= "(" || %button $= ")")
	{
		if($Calculator_String $= "0")
		{
			$Calculator_String = "";
		}
		$Calculator_String = $Calculator_String SPC %button;
		Calculator_Screen.setValue("\c7" @ $Calculator_String);
	}
	else if(%button $= "." ||  %button == 0 || %button == 1 || %button == 2 || %button == 3 || %button == 4 || %button == 5 || %button == 6 || %button == 7 || %button == 8 || %button == 9)
	{
		if($Calculator_String $= "0" && %button !$= ".")
		{
			$Calculator_String = "";
		}
		if(lastWord($Calculator_String) $= "+" || lastWord($Calculator_String) $= "-" || lastWord($Calculator_String) $= "/" || lastWord($Calculator_String) $= "x" || lastWord($Calculator_String) $= "(" || lastWord($Calculator_String) $= ")" || lastWord($Calculator_String) $= "^")
		{
			$Calculator_String = $Calculator_String SPC %button;
		}
		else
		{
			$Calculator_String = $Calculator_String @ %button;
		}
		Calculator_Screen.setValue("\c7" @ $Calculator_String);
	}
}